# Contributing

Mikrokosmos is open to pull requests and issue reports from
everyone. The code is licensed under the GNU General Public License
Version 3 (see the LICENSE file).


## Issues

Any bug, failure, or unintended behaviour of the program, specially if
it differs from the behaviour described on the [user's guide](https://mroman42.github.io/mikrokosmos/userguide.html),
should be reported on the relevant [issue tracker](https://github.com/mroman42/mikrokosmos/issues).
When doing so, please try to include all the relevant information, the
steps you may take to reproduce the error, and the platform and version
of Mikrokosmos you were using.

Please note that this project has not a full-time maintainer.  Issues
may take a long time to resolve and we cannot guarantee that they will
be solved eventually. Priority will be given to issues on the
evaluation and type inference algorithms.


## Pull requests

A pull request should ideally answer an issue.  Pull requests that
simply solve a bug are more likely to get accepted.  Before commiting
your time to the implementation of new feature, please open an issue
describing the desired changes and wait for feedback on whether that
particular feature would be suitable for Mikrokosmos.

In order to submit a pull request,
[fork](https://help.github.com/articles/fork-a-repo/) and
[clone](https://git-scm.com/docs/git-clone) the
repository. Install the
[stack](https://docs.haskellstack.org/en/stable/README/) tool
(or similar). After editing the code, Mikrokosmos can be rebuilt using
`stack install`. Before making your changes and before submitting your
pull request, make sure all the tests pass using `stack test`.

Please write descriptive commit messages and clearly state on the pull
request the intended effect of your changes. Please note that this
project has not a full-time maintainer; pull requests may take some
time to get accepted. We may suggest changes or improvements to the pull
request.
