# mikrokosmos

![Version](https://img.shields.io/badge/version-0.8.0-blue.svg)
![Travis (.org)](https://img.shields.io/travis/mroman42/mikrokosmos.svg)

**Mikrokosmos** is a λ-calculus interpreter, borrowing its name from the series of
progressive piano études *[Mikrokosmos](https://www.youtube.com/watch?v=VEsMk3DAzWM)* written by *Bela Bartok*. 
It aims to provide students with a tool to learn and understand λ-calculus. It supports both untyped λ-calculus 
and simply typed λ-calculus.

 * [Try Mikrokosmos!](https://mroman42.github.io/mikrokosmos/), online interpreter.
 * [Mikrokosmos tutorial](https://mroman42.github.io/mikrokosmos/tutorial.html), an online tutorial.
 * [Mikrokosmos user's guide](https://mroman42.github.io/mikrokosmos/userguide.html), contains installation instructions.
 * [Mikrokosmos on Hackage](https://hackage.haskell.org/package/mikrokosmos).

## Support and contributions

If you are an user seeking support, please use the 
[GitHub issue tracker](https://github.com/mroman42/mikrokosmos/issues) 
of the main repository.  Any bug, failure, or unintended behaviour of the program, specially if
it differs from the behaviour described on the [user's guide](https://mroman42.github.io/mikrokosmos/userguide.html),
should be reported on the [issue tracker](https://github.com/mroman42/mikrokosmos/issues).
When doing so, please try to include all the relevant information, the
steps you may take to reproduce the error, and the platform and version
of Mikrokosmos you were using.

Mikrokosmos is open to pull requests and issue reports from everyone
(please see the CONTRIBUTING file).  The code is licensed under the GNU
General Public License Version 3 (see the LICENSE file).
